<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects. 
======================================================================= -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
  	extension-element-prefixes="redirect"> 
	
	<xsl:output method="html" encoding="UTF-8"/>

	<xsl:param name="root-path"/>    
    <xsl:param name="radar-config-doc"/>    

<xsl:key name="metrics" match="packages/package/statistics" use="." />

<!-- test version only. not part of release -->	    
<xsl:template match="radar-report">
    <redirect:write file="reports/packages-report.html">
        <html>
            <table>
                <xsl:apply-templates select="packages/package[position()=1]" mode="header"/>
                <xsl:apply-templates select="packages/package" mode="data"/>
            </table>
        </html>
</redirect:write>
</xsl:template>
   	

<xsl:template match="package" mode="header">
    <tr><th>Subsystem</th><th>Package</th>
    <xsl:for-each select="/radar-report/metrics/package/metric">
        <th><xsl:value-of select="concat(@group,':',@name)"/></th>
    </xsl:for-each></tr>
</xsl:template>

<xsl:template match="package" mode="data">
    <tr><td><xsl:value-of select="@subsystem"/></td><td><xsl:value-of select="@name"/></td>
    <xsl:variable name="package-node" select="current()"/>
    <xsl:for-each select="/radar-report/metrics/package/metric">
        <xsl:variable name="group" select="@group"/>
        <xsl:variable name="name" select="@name"/>
        <td><xsl:value-of select="$package-node/statistics/child::*[name()=$group]/child::*[name()=$name]"/></td>
    </xsl:for-each></tr>
</xsl:template>

</xsl:stylesheet>